pulsesink: Segfault in pulsesink.c:2077 gst_pulsesink_pad_acceptcaps()

Bug #1068155 reported by Erik Botö on 2012-10-18
14
This bug affects 1 person
Affects Status Importance Assigned to Milestone
gst-plugins-good
Fix Released
Medium
gst-plugins-good0.10 (Ubuntu)
Low
Unassigned
Precise
Low
Unassigned
Quantal
Low
Unassigned

Bug Description

Impact:
segfaults happening sometimes

Test Case:
No easy way to reproduce, the bug reporter has access to a closed source app which tends to trigger the issue and can do testing on it though

Regression potential:
Check that sound and video playing in rhythmbox, totem, etc still work as it should...

-----

There's an upstream bug at: https://bugzilla.gnome.org/show_bug.cgi?id=683782

I looked at the suggested patch and made it work in the source package of Ubuntu 12.04, see attached patch. This applies cleanly on top a fresh apt-get source gst-plugins-good0.10 . Using this patch solves our crash.

The source package is: gst-plugins-good0.10

$ lsb_release -rd
Description: Ubuntu 12.04.1 LTS
Release: 12.04

$ apt-cache policy gstreamer0.10-pulseaudio
gstreamer0.10-pulseaudio:
  Installed: 0.10.31-1ubuntu1
  Candidate: 0.10.31-1ubuntu1
  Version table:
 *** 0.10.31-1ubuntu1 0
        500 http://se.archive.ubuntu.com/ubuntu/ precise/main i386 Packages
        100 /var/lib/dpkg/status

Erik Botö (erik-boto) wrote :

The attachment "pulsesink-fix.patch" of this bug report has been identified as being a patch. The ubuntu-reviewers team has been subscribed to the bug report so that they can review the patch. In the event that this is in fact not a patch you can resolve this situation by removing the tag 'patch' from the bug report and editing the attachment so that it is not flagged as a patch. Additionally, if you are member of the ubuntu-reviewers team please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by Brian Murray. Please contact him regarding any issues with the action taken in this bug report.]

tags: added: patch
David Henningsson (diwic) wrote :

Hi Erik and thanks for your patch!

Could you give a good test example on how to reproduce the crash? This is going to be necessary if you want it to reach a stable release of Ubuntu. See https://wiki.ubuntu.com/StableReleaseUpdates for details.

Changed in gst-plugins-good0.10 (Ubuntu):
status: New → Incomplete
Erik Botö (erik-boto) wrote :

Unfortunately (or maybe fortunately) I can only reproduce the problem using a some of our closed source code, and even then it's a relatively uncommon crash. I only had a small amount of time playing around trying to trigger the bug in a minimal test, but were unable to do so.

I understand that this might disqualify it from getting into the stable release. If someone else has the same issue they'll hopefully find this bug and can build a fixed version of their own, just like we do internally.

Sebastien Bacher (seb128) wrote :

it's possible to SRU with a testcase stating that the bug is hard to trigger and that testers should ensure things keep working without regression

Changed in gst-plugins-good0.10 (Ubuntu):
importance: Undecided → Low
status: Incomplete → Triaged
Changed in gst-plugins-good0.10 (Ubuntu Precise):
importance: Undecided → Low
status: New → Triaged
Sebastien Bacher (seb128) wrote :

The patch commited upstream:
http://cgit.freedesktop.org/gstreamer/gst-plugins-good/patch/?id=d2fdc26c38acc243ba7912f4db17f63fe0d54632

is slightly different ... is there any chance you could test it/make it apply to the current gst-plugins-good version (seems to not apply in its current form to 0.10.31)

Erik Botö (erik-boto) wrote :

Updated patch. Tested it and it also solves the crash we see.

Changed in gst-plugins-good0.10 (Ubuntu Quantal):
importance: Undecided → Low
status: New → Triaged
Changed in gst-plugins-good0.10 (Ubuntu):
status: Triaged → Fix Committed
Changed in gst-plugins-good0.10 (Ubuntu Precise):
status: Triaged → In Progress
Changed in gst-plugins-good0.10 (Ubuntu Quantal):
status: Triaged → In Progress
description: updated
Changed in gst-plugins-good:
importance: Unknown → Medium
status: Unknown → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gst-plugins-good0.10 - 0.10.31-3ubuntu3

---------------
gst-plugins-good0.10 (0.10.31-3ubuntu3) raring; urgency=low

  * debian/patches/git_new_v4l_building.patch: "v4l2: fix build with
    recent kernels, the v4l2_buffer input field was removed"
 -- Sebastien Bacher <email address hidden> Fri, 16 Nov 2012 15:06:05 +0100

Changed in gst-plugins-good0.10 (Ubuntu):
status: Fix Committed → Fix Released
madbiologist (me-again) on 2012-11-20
tags: added: precise

Hello Erik, or anyone else affected,

Accepted gst-plugins-good0.10 into quantal-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/gst-plugins-good0.10/0.10.31-3ubuntu1.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in gst-plugins-good0.10 (Ubuntu Quantal):
status: In Progress → Fix Committed
tags: added: verification-needed
Changed in gst-plugins-good0.10 (Ubuntu Precise):
status: In Progress → Fix Committed
Clint Byrum (clint-fewbar) wrote :

Hello Erik, or anyone else affected,

Accepted gst-plugins-good0.10 into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/gst-plugins-good0.10/0.10.31-1ubuntu1.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Iain Lane (laney) wrote :

Erik,

Are you now running the -proposed versions of gst-plugins-good0.10? Can you verify that they fix the issue? We need someone to confirm this before the packages can be rolled out to all users.

I'd like to fix a different bug in this package in the stable releases and it's preferable that we finish this fix up before doing that.

Cheers.

Erik Botö (erik-boto) wrote :

Hi,

Sorry for the lack of feedback!

I have tested the precise-proposed version of gstreamer0.10-pulseaudio and I can verify that is solves the crash we see with the vanilla version.

Cheers.

Iain Lane (laney) on 2013-02-13
tags: added: verification-done
removed: verification-needed

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gst-plugins-good0.10 - 0.10.31-1ubuntu1.1

---------------
gst-plugins-good0.10 (0.10.31-1ubuntu1.1) precise-proposed; urgency=low

  * debian/patches/git_ring_buffer_null_check.patch: segfault fix,
    thanks Erik Botö for backporting and testing the change (lp: #1068155)
 -- Sebastien Bacher <email address hidden> Fri, 16 Nov 2012 12:51:49 +0100

Changed in gst-plugins-good0.10 (Ubuntu Precise):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package gst-plugins-good0.10 - 0.10.31-3ubuntu1.1

---------------
gst-plugins-good0.10 (0.10.31-3ubuntu1.1) quantal-proposed; urgency=low

  * debian/patches/git_ring_buffer_null_check.patch: segfault fix,
    thanks Erik Botö for backporting and testing the change (lp: #1068155)
 -- Sebastien Bacher <email address hidden> Fri, 16 Nov 2012 12:51:49 +0100

Changed in gst-plugins-good0.10 (Ubuntu Quantal):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.